   

import bluej.extensions.*;
import bluej.extensions.event.*;
import bluej.extensions.editor.*;

import java.net.URL;
import javax.swing.*;
import java.awt.event.*;


/**
 * Clase MenuBuilder
 * Generador Menu Herramientas y Clase
 * 
 * @author (Milton Jes&uacute;s Vera Contreras - miltonjesusvc@ufps.edu.co) 
 * @version 0.0000000000000001 --> Math.sin(Math.PI-Double.MIN_VALUE) --> :)
 */
class MenuBuilder extends MenuGenerator {

    private GetterSetterExtension ext;
    
    public MenuBuilder(GetterSetterExtension ext)
    {
        //super();
        this.ext = ext;
    }//fin constructor

    public JMenuItem getClassMenuItem(BClass aClass) {
        JMenu jm = new JMenu("GetterSetter");
        JMenuItem jm0 = new JMenuItem(new AboutAction());        
        JMenu jm1 = new JMenu("Generate Getter");
        JMenu jm2 = new JMenu("Generate Setter");
        JMenuItem jm3 = new JMenuItem(new GetterSetterAction(aClass));
        jm.add(jm0);
        jm.add(jm3);        
        jm.add(jm1);
        jm.add(jm2);
        try{
          GetterSetterIntrospector gsi = new GetterSetterIntrospector(aClass);
          String [] propertiesWithoutGet = gsi.getPropertiesWithoutGet();
          String [] propertiesWithoutSet = gsi.getPropertiesWithoutSet();
          for(int i=0; i< propertiesWithoutGet.length;i++) jm1.add(new GetterAction(aClass, propertiesWithoutGet[i]));
          for(int i=0; i< propertiesWithoutSet.length;i++) jm2.add(new SetterAction(aClass, propertiesWithoutSet[i]));
        }catch(Exception e){}
        return jm;
    }//fin getClassMenuItem

    public JMenuItem getObjectMenuItem(BObject anObject) {
        return new JMenuItem(new ObjectSetterAction (anObject));
    }//fin getObjectMenuItem
       
    
    // These methods will be called when
    // each of the different menus are about to be invoked.
    public void notifyPostToolsMenu(BPackage bp, JMenuItem jmi) {
        System.out.println("Post on Tools menu");
        ext.setCurPackage(bp);
        ext.setCurClass(null);
        ext.setCurObject(null);
    }//fin notifyPostToolsMenu
    
    public void notifyPostClassMenu(BClass bc, JMenuItem jmi) {
        System.out.println("Post on Class menu");
        ext.setCurPackage(null);
        ext.setCurClass(bc);
        ext.setCurObject(null);
    }//fin notifyPostClassMenu
    
    public void notifyPostObjectMenu(BObject bo, JMenuItem jmi) {
        System.out.println("Post on Object menu");
        ext.setCurPackage(null);
        ext.setCurClass(null);
        ext.setCurObject(bo);
    }//fin notifyPostObjectMenu
   
    /**Generate ALL GET/SET methods*/
    class GetterSetterAction extends AbstractAction {
        public GetterSetterAction(BClass bc) {
            putValue(AbstractAction.NAME, "Generate All Getter/Setter Methods");
            ext.setCurClass(bc);
        }
        public void actionPerformed(ActionEvent evt) {
          try{
           ext.genGetterSetter();
          }
          catch(Exception e){
            java.io.StringWriter errors = new java.io.StringWriter();
            e.printStackTrace(new java.io.PrintWriter(errors));
            JOptionPane.showMessageDialog(null, "GetterSetterAction:\n" + errors.toString());
          }
        }//fin 
    }//fin clase
    
    /**Generate GET method*/
    class GetterAction extends AbstractAction {
        private String propertie;
        public GetterAction(BClass bc, String propertie) {
            putValue(AbstractAction.NAME, propertie);
            this.propertie = propertie;
            ext.setCurClass(bc);
        }
        public void actionPerformed(ActionEvent evt) {
          try{
           ext.genGetter(propertie);
          }
          catch(Exception e){
             java.io.StringWriter errors = new java.io.StringWriter();
            e.printStackTrace(new java.io.PrintWriter(errors));
            JOptionPane.showMessageDialog(null, "GetterAction:\n" + errors.toString());
          }
        }//fin 
    }//fin clase
    
    /**Generate SET method*/
    class SetterAction extends AbstractAction {
        private String propertie;
        public SetterAction(BClass bc, String propertie) {
            putValue(AbstractAction.NAME, propertie);
            this.propertie = propertie;
            ext.setCurClass(bc);
        }
        public void actionPerformed(ActionEvent evt) {
          try{
           ext.genSetter(propertie);
          }
          catch(Exception e){
             java.io.StringWriter errors = new java.io.StringWriter();
            e.printStackTrace(new java.io.PrintWriter(errors));
            JOptionPane.showMessageDialog(null, "SetterAction:\n" + errors.toString());
          }
        }//fin 
    }//fin clase    
    
    /**Generate GUI javax.swing to view/edit object'properties with GET/SET methods*/
    class ObjectSetterAction extends AbstractAction {
        public ObjectSetterAction(BObject bo) {
            putValue(AbstractAction.NAME, "Edit using Setter Methods");
            ext.setCurObject(bo);
        }
        public void actionPerformed(ActionEvent evt) {
          try{
           ext.setterObject();
          }
          catch(Exception e){
            JOptionPane.showMessageDialog(null, "Error Edit using Setter Methods " +e.getMessage());
            try{e.printStackTrace(new java.io.PrintStream(new java.io.FileOutputStream("errorGetterSetterExtension.txt")));}catch(Exception e1){}
          }
        }//fin 
    }//fin clase    
    
    /**About Action*/
    class AboutAction extends AbstractAction{
       public AboutAction(){
          putValue(AbstractAction.NAME, "About");
       }
       
       public void actionPerformed(ActionEvent t){
         try{
             String text = "Getter Setter Extension\n";
             text      +=  "Milton Jesús Vera Contreras\n";
             text      +=  "Universidad Francisco de Paula Santander\n";
             text      +=  "Cúcuta-Colombia\n";
             text      +=  "miltonjesusvc@ufps.edu.co - miljeveco@gmail.com\n";
             text      +=  "Version 0.0000000000000001 --> Math.sin(Math.PI-Double.MIN_VALUE) --> :)\n";
             text      +=  "Diciembre de 2018";
             JOptionPane.showMessageDialog(null, text);
         }
         catch(Exception e){
             JOptionPane.showMessageDialog(null, e.getMessage());
         }
       }
    }
    
}//fin clase